Subject: r8169: Fix card drop incoming VLAN tagged MTU byte large jumbo frames

From: Raimonds Cicans <[email-masked]>
Date: Mon, 26 Oct 2009 22:52:37 +0200

r8169 card drop incoming VLAN tagged MTU byte large jumbo frames

It looks to compare current and maximal packet sizes hardware use
'<' operator, not '<='.

Bug introduced by patch:
r8169: fix crash when large packets are received

Signed-off-by: Raimonds Cicans <[email-masked]>

---

--- linux-2.6.31/drivers/net/r8169.c.orig	2009-10-26 20:57:47.256658618 +0200
+++ linux-2.6.31/drivers/net/r8169.c	2009-10-26 19:48:25.807252812 +0200
@@ -2365,7 +2365,7 @@ static u16 rtl_rw_cpluscmd(void __iomem 
 static void rtl_set_rx_max_size(void __iomem *ioaddr, unsigned int rx_buf_sz)
 {
 	/* Low hurts. Let's disable the filtering. */
-	RTL_W16(RxMaxSize, rx_buf_sz);
+	RTL_W16(RxMaxSize, rx_buf_sz + 1);
 }
 
 static void rtl8169_set_magic_reg(void __iomem *ioaddr, unsigned mac_version)